// CMD line module (AVInfo)
// parsing command line, setup template variable

// History:
// added 13.02.03 (v0.7)
// fixed '-' (06.08.03)

void Init(char *info[],file_data *file_d, char* template[]) {
//set default config & global variable
    int counter;
    for(counter=0;counter<23;counter++)info[counter]=NULL;
	flags.disable.info=0;      
	flags.disable.eight=0;        
	flags.disable.accuracy=0;
	flags.error.message=1;
	flags.error.ignore=0;
	flags.direct.header=1;//use "direct" reading.
	flags.ogm=0;
	file_d->filename="";
	file_d->size=0;
	template[0]=default_template[0];
	template[1]=default_template[1];

}



int check_predefined_template(const char *line){
//compare line with signatures and return number of eqv.
//return -1 if nothing found;
	int counter;
	for(counter=0;counter<PREDEFINED_NUMBER;counter++)
		if(!strcmp(predefined[counter][0],line) ) return counter;
	return -1;
}


int CMDlineParse (int argc, char *argv[],  file_data *file_d, char *template[]){
//parse command line, check switches, params, and setuping global config variables.
//printing help (if needs), exits (if needs)
//return value -1 if some errors has been, 0 - if no errors.
	#define CMD_MODE_NORM 0
	#define CMD_MODE_SWITCH 1  	//some like avinfo -foo bar
	#define CMD_MODE_DEFINE 2 	//some like avinfo --foo bar (predefined templates)
	#define CMD_MODE_NAME 3 	//filename
	#define CMD_MODE_TEMPLATE 4 

	int counter; //current param
	char *pointer; //current char in param
	int state=CMD_MODE_NORM;
	int name_flag=0; //flag, if=0, no name found till yet, if = 1 name parsed
	int template_number=0; //0 if no template till yet, 1, if template 1, 2 if template 2
	int template_predef=0;//predefined number of template
	char *buffer=malloc(65535);
	if (argc<2) exit(puts(help_message)); //no command line params
	for(counter=1; counter<argc; counter++){
		for(pointer=argv[counter];*pointer;pointer++){
			switch(state){
				case CMD_MODE_NORM:
					switch(*pointer){
						case '-': state=CMD_MODE_SWITCH;
								  continue;
								  break;
						default: if(name_flag){
									pointer--;
									state=CMD_MODE_TEMPLATE;
									continue;
								 }
								 else{
									pointer--; //roll back
									state=CMD_MODE_NAME;
									continue;
								 }
								 break;
					}
					break;
				case CMD_MODE_SWITCH:
					switch (*pointer){
						case '-': state=CMD_MODE_DEFINE;
								  break;
						case 'o': state=CMD_MODE_NORM;
								  flags.ogm=1;
								  break;
						case 'f':  //disable option
								for(pointer++;*pointer;pointer++){
									switch(*pointer){
										case 'a': flags.disable.accuracy=1;
												break;
									    case 'h': flags.disable.header=1;//no MainAVIHeader reading
									    		break;
										case 'i': flags.disable.info=1; //turn off INFO
												break;
										case '7': flags.disable.eight=1; //no 8'th bit
												break;
										case 'x': flags.disable.index=1;//no index reading
												break;
										case 'A': flags.disable.accuracy=0;
												break;
										case 'H': flags.disable.header=0; //turn no header
												break;
										case 'I': flags.disable.info=0;//turn on info
												break;
										case '8': flags.disable.eight=0;//full 8-bit output
												break;
										case 'X': flags.disable.index=0;//turn on index
												break;
//TODO!										case 'd': flags.direct.header=!flags.direct.header;//do not use direct reading, use "right" avi parsing
//												break;
									}
								}
								pointer--;//roll back, *(pointer+1)=='\x0';
								state=CMD_MODE_NORM; //return to next param with normal state
								continue; //to next param
								break;
						case 'e' ://option for error processing
								for(pointer++;*pointer;pointer++){
									switch(*pointer){
										case 'i': flags.error.ignore=1; //IGNORE ERRROR
												break;
										case 'm': flags.error.message=1; //print message about error
												break;
									    case 'e': flags.error.ignore=0;//exit on errors
									    		break;
										case 's': flags.error.message=0;//silence mode
												break;
									}
								}
								pointer--;//roll back, *(pointer+1)=='\x0';
								state=CMD_MODE_NORM; //return to next param with normal state
								continue;//to next param in CMDline
								break;
						default: //skip unknown switches
								printf("%s is unknown switch\n",pointer);
								pointer=pointer+strlen(pointer)-1;//*(pointer+1)=='\x0';
								state=CMD_MODE_NORM;
					}
					break;
				case CMD_MODE_DEFINE:
					if(*pointer>='0' && *pointer<=PREDEFINED_NUMBER+'0'){
						template[0]=predefined[*pointer-'0'][1];
						template[1]=predefined[*pointer-'0'][2];						
						state=CMD_MODE_NORM;
						pointer+=strlen(pointer)-1;
						break;
					}
					template_predef=check_predefined_template(pointer);
					if(template_predef!=-1){
						template[0]=predefined[template_predef][1];
						template[1]=predefined[template_predef][2];
					}
					else puts("No such predefined template");
					pointer+=strlen(pointer)-1;
					state=CMD_MODE_NORM;
					break;
				case CMD_MODE_NAME:
					file_d->filename=pointer;
					pointer+=strlen(pointer)-1;
					state=CMD_MODE_NORM;
					name_flag=1;
					break;
				case CMD_MODE_TEMPLATE:
					if(*pointer=='+') {
						template[template_number]=default_template[template_number++];
						pointer+=strlen(pointer)-1;
						state=CMD_MODE_NORM;
    					break;
					}
					if(*pointer=='?'){
						gets(buffer);
						template[template_number++]=buffer;
						buffer+=strlen(buffer);
						pointer+=strlen(pointer)-1;
						state=CMD_MODE_NORM;
						break;
					}
					template[template_number++]=pointer;
					pointer+=strlen(pointer)-1;
					state=CMD_MODE_NORM;
					break;
			}
		}
	}
	if(flags.disable.accuracy){
//Thanx to Slava Suhanov (2:5030/1045) for this idea.
		if (strlen(GetFileNameOnly(file_d->filename,0))>40 && template_predef==0){//compress output (if "description") to the 80 chars.
			template[0]="%J: %sb %xx%y\n";
			template[1]="";
			flags.disable.info=1; //turn off unnesesary for this template
			flags.disable.index=1;
			flags.disable.streams=1;
		}
		if(strlen(GetFileNameOnly(file_d->filename,0))>67 && template_predef==0){
			template[0]="%J: %xx%y\n";
		}
	}
///*DEBUG*/printf("(debug) flags: no_info=%d, no_streams=%d, seven=%d, error_ignore=%d, error_message=%d\n", flags.no_info,flags.no_streams,flags.seven,flags.error_ignore,flags.error_message);
    if(!*file_d->filename) exit(puts(help_message));
	return 0;
}

//redo (from avinfo.c)
/*    if (!strcmp(argv[1],"--codec")){
    	if (argc<3) return puts("Usage: avinfo --codec FOURCC");
    	if (strlen(argv[2])>4) return puts ("FOURCC must be no more then 4 chars");
    	fill(buffer,' ',4);
    	sscanf(argv[2], "%s", buffer);
		FormatCodecInfo(buffer);	
		puts(buffer);
		free (buffer);
		return 0;
	}*/
